<template>
	<div class="layer-bg">
		<!-- <MkPasswordForm :page-response="page"/> -->
		<ValidationObserver ref="forgot_validation_observer" class="flex items-center justify-center m-auto">
			<div class="mx-auto w-full md:w-690 md:pt-24 md:mb-60 lg:pt-16 lg:mb-32">
				<p
					v-show="PASSWORD_ERROR && !errorType"
					role="alert"
					class="py-2 mb-8 text-base leading-6 text-center text-black rounded-md bg-error-10 font-primary-font-light"
				>
					{{ PASSWORD_ERROR }}
				</p>
				<div
					class="flex flex-col md:justify-center md:items-center md:rounded-tr-lg lg:rounded-t md:h-184 lg:min-h-216 bg-mint-20 px-4 py-6 md:px-6 md:pt-12 md:pb-14 lg:px-14 lg:pt-14"
				>
					<h1 class="font-secondary-font-regular text-2xl md:text-28 lg:text-base2 leading-7 md:leading-8">
						{{ isResetpage ? resetTitle.heading : forgetTitle.heading }}
					</h1>
					<p class="pt-8 md:pt-6 lg:pt-10 font-primary-font-light text-base leading-6">
						{{ isResetpage ? resetTitle.subTitle : forgetTitle.subTitle }}
					</p>
				</div>
				<div class="bg-white lg:rounded-b py-8 px-4 md:px-10 md:py-12 lg:p-14">
					<div v-if="page && errorType">
						<p
							role="alert"
							class="py-2 mb-2 text-base leading-6 text-center text-black rounded-md bg-error-10 font-primary-font-light"
							v-html="page.resetfailed"
						>
						</p>
						<p
							role="alert"
							class="py-2 mb-8 text-base leading-6 text-center text-black rounded-md bg-error-10 font-primary-font-light"
							v-html="page.resetexpired"
						>
						</p>
					</div>
					<MkInput
						v-if="!isResetpage"
						:id="activePage + '_email'"
						label="Email"
						:value="email"
						rules="required|email"
						variant="outline"
						@input="($value) => (email = $value)"
					/>
					<div v-if="isResetpage" class="relative">
						<MkInput
							:id="activePage + '_pwd'"
							label="Create new password"
							:value="password"
							rules="required|valid_password"
							type="password"
							variant="outline"
							:vid="activePage + '_password'"
							@input="($value) => (password = $value)"
						/>
						<div
							class="inline-block focus:outline-none absolute right-0 top-0 transform translate-y-5 group p-0.5 mk-tooltip"
							role="tooltip"
							tabindex="0"
						>
							<span class="icon-notification" aria-label="Password must be"></span>
							<MkCartTooltip class="hidden group-hover:block" :rotate-left="true" :icon-position="toolTipPosition">
								<template #tooltipRightValue>
									<p>8 character min.</p>
									<p>1 lowercase letter</p>
									<p>1 number</p>
									<p>1 uppercase letter</p>
									<p>1 special character</p>
								</template>
							</MkCartTooltip>
						</div>
					</div>
					<MkInput
						v-if="isResetpage"
						:id="activePage + '_cnfm_pwd'"
						label="Confirm new password"
						class="mt-8"
						:value="confirmPassword"
						:rules="`required|confirmed:${activePage}_password`"
						type="password"
						variant="outline"
						@input="($value) => (confirmPassword = $value)"
					/>
					<div>
						<MkPrimaryButton
							:loading="submitProcess"
							:disabled="!enableButton"
							class="mt-10 md:mt-6 lg:mt-10 font-primary-font-regular text-base md:text-xl leading-6"
							:button-title="isResetpage ? resetTitle.buttonTitle : forgetTitle.buttonTitle"
							@click="resetPassword"
						/>
					</div>
				</div>
			</div>
		</ValidationObserver>
	</div>
</template>

<script>
// import MkPasswordForm from '~/components/D2C/molecules/MkPasswordForm.vue'
import { mapState } from 'vuex';
import { ValidationObserver } from 'vee-validate';
import MkPrimaryButton from '~/components/D2C/atoms/MkPrimaryButton.vue';
import MkInput from '~/components/D2C/atoms/MkInput.vue';
import MkCartTooltip from '~/components/D2C/atoms/MkCartTooltip.vue';
export default {
	components: {
		MkInput,
		MkPrimaryButton,
		ValidationObserver,
		MkCartTooltip,
	},
	layout: 'aurora-layout',
	async asyncData({ store, req }) {
		return { page: await store.dispatch('pages/FETCH_PAGE_DATA', { pageName: 'my_login_page', req }) };
	},
	data() {
		return {
			submitProcess: false,
			email: '',
			confirmPassword: '',
			password: '',
			resetTitle: {
				heading: 'Reset password',
				subTitle: 'Create a new password.',
				buttonTitle: 'Reset password',
			},
			forgetTitle: {
				heading: 'Forgot your password?',
				subTitle: 'Enter your email address to receive a password reset link.',
				buttonTitle: 'Reset my password',
			},
			activePage: 'forget',
			isResetpage: false,
			errorType: '',
		};
	},
	head() {
		return {
			title: 'PasswordReset',
		};
	},
	computed: {
		...mapState('USER_STORE', ['PASSWORD_ERROR']),
		enableButton() {
			let disableButton = false;
			if (
				(this.email === '' && !this.isResetpage) ||
				(this.isResetpage && this.password === '' && this.confirmPassword === '')
			) {
				disableButton = false;
			} else {
				disableButton = true;
			}
			return disableButton;
		},
	},
	mounted() {
		this.activePage = this.$route.query.type ? this.$route.query.type : 'forget';
		this.isResetpage = this.activePage === 'reset' || this.activePage === 'create';
	},
	methods: {
		updateForm(value) {
			if (value === 'email') this[value] = value;
		},
		decodeEmail(value) {
			return decodeURIComponent(value); // value.replace(/\+/g, ''));
		},
		async resetPassword() {
			const isValidForm = await this.$refs.forgot_validation_observer.validate();
			if (isValidForm) {
				this.submitProcess = true;
				try {
					if (!this.isResetpage) {
						await this.$store.dispatch('USER_STORE/FORGOT_PASSWORD_NW', this.email);
						this.$router.push('/D2C/login/?from=forget');
					} else {
						const res = await this.$store.dispatch('USER_STORE/RESET_PASSWORD', {
							confirmationCode: this.$route.query.token,
							emailId: this.decodeEmail(this.$route.query.email),
							password: this.password,
						});
						if (res === 'success') {
							this.$router.push('/D2C/login/');
							this.errorType = '';
						} else {
							this.$router.push('/D2C/login/passwordReset/');
							this.errorType = 'resetError';
							this.isResetpage = false;
						}
					}
				} catch (e) {
					// console.log("couldn't reset password", e);
				}
				this.submitProcess = false;
			}
		},
	},
};
</script>
